/*
   +----------------------------------------------------------------------+
   | HipHop for PHP                                                       |
   +----------------------------------------------------------------------+
   | Copyright (c) 2010-2013 Facebook, Inc. (http://www.facebook.com)     |
   | Copyright (c) 1997-2010 The PHP Group                                |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
*/

#ifndef incl_HPHP_EXT_FB_H_
#define incl_HPHP_EXT_FB_H_

// >>>>>> Generated by idl.php. Do NOT modify. <<<<<<

#include "hphp/runtime/base/base_includes.h"

namespace HPHP {
///////////////////////////////////////////////////////////////////////////////

Variant f_fb_thrift_serialize(CVarRef thing);
Variant f_fb_thrift_unserialize(CVarRef thing, VRefParam success, VRefParam errcode = null_variant);
Variant f_fb_serialize(CVarRef thing);
Variant f_fb_unserialize(CVarRef thing, VRefParam success, VRefParam errcode = null_variant);
Variant f_fb_compact_serialize(CVarRef thing);
Variant f_fb_compact_unserialize(CVarRef thing, VRefParam success, VRefParam errcode = null_variant);
bool f_fb_could_include(CStrRef file);
bool f_fb_intercept(CStrRef name, CVarRef handler, CVarRef data = null_variant);
Variant f_fb_stubout_intercept_handler(CStrRef name, CVarRef obj, CArrRef params, CVarRef data, VRefParam done);
Variant f_fb_rpc_intercept_handler(CStrRef name, CVarRef obj, CArrRef params, CVarRef data, VRefParam done);
void f_fb_renamed_functions(CArrRef names);
bool f_fb_rename_function(CStrRef orig_func_name, CStrRef new_func_name);
bool f_fb_autoload_map(CVarRef map, CStrRef root);
bool f_fb_utf8ize(VRefParam input);
int64_t f_fb_utf8_strlen_deprecated(CStrRef input);
int64_t f_fb_utf8_strlen(CStrRef input);
Variant f_fb_utf8_substr(CStrRef str, int start, int length = INT_MAX);
Array f_fb_call_user_func_safe(int _argc, CVarRef function, CArrRef _argv = null_array);
Variant f_fb_call_user_func_safe_return(int _argc, CVarRef function, CVarRef def, CArrRef _argv = null_array);
Array f_fb_call_user_func_array_safe(CVarRef function, CArrRef params);
Variant f_fb_get_code_coverage(bool flush);
void f_fb_enable_code_coverage();
Variant f_fb_disable_code_coverage();
void f_xhprof_enable(int flags = 0, CArrRef args = null_array);
Variant f_xhprof_disable();
void f_xhprof_network_enable();
Variant f_xhprof_network_disable();
void f_xhprof_frame_begin(CStrRef name);
void f_xhprof_frame_end();
Variant f_xhprof_run_trace(CStrRef packedTrace, int flags);
void f_xhprof_sample_enable();
Variant f_xhprof_sample_disable();
void f_fb_load_local_databases(CArrRef servers);
Array f_fb_parallel_query(CArrRef sql_map, int max_thread = 50, bool combine_result = true, bool retry_query_on_fail = true, int connect_timeout = -1, int read_timeout = -1, bool timeout_in_ms = false);
Array f_fb_crossall_query(CStrRef sql, int max_thread = 50, bool retry_query_on_fail = true, int connect_timeout = -1, int read_timeout = -1, bool timeout_in_ms = false);
Variant f_fb_const_fetch(CVarRef key);
bool f_fb_output_compression(bool new_value);
void f_fb_set_exit_callback(CVarRef function);
Array f_fb_get_flush_stat();
int64_t f_fb_get_last_flush_size();
Variant f_fb_lazy_stat(CStrRef filename);
Variant f_fb_lazy_lstat(CStrRef filename);
String f_fb_lazy_realpath(CStrRef filename);
void f_fb_setprofile(CVarRef callback);
String f_fb_gc_collect_cycles();
void f_fb_gc_detect_cycles(CStrRef filename);
extern const int64_t k_FB_UNSERIALIZE_NONSTRING_VALUE;
extern const int64_t k_FB_UNSERIALIZE_UNEXPECTED_END;
extern const int64_t k_FB_UNSERIALIZE_UNRECOGNIZED_OBJECT_TYPE;
extern const int64_t k_FB_UNSERIALIZE_UNEXPECTED_ARRAY_KEY_TYPE;
extern const int64_t k_XHPROF_FLAGS_NO_BUILTINS;
extern const int64_t k_XHPROF_FLAGS_CPU;
extern const int64_t k_XHPROF_FLAGS_MEMORY;
extern const int64_t k_XHPROF_FLAGS_VTSC;
extern const int64_t k_XHPROF_FLAGS_TRACE;
extern const int64_t k_XHPROF_FLAGS_MEASURE_XHPROF_DISABLE;
extern const int64_t k_XHPROF_FLAGS_MALLOC;

///////////////////////////////////////////////////////////////////////////////

int fb_unserialize_from_buffer(Variant &res, const char *buff, int buff_len,
                               int *pos);
int fb_compact_unserialize_from_buffer(Variant &res, const char *buff,
                                       int buff_len, int &pos);
Variant fb_unserialize(const char* str, int len, VRefParam success,
                       VRefParam errcode = null_variant);
Variant fb_compact_unserialize(const char* str, int len,
                               VRefParam success,
                               VRefParam errcode = null_variant);

///////////////////////////////////////////////////////////////////////////////
}

#endif // incl_HPHP_EXT_FB_H_
