/*
   +----------------------------------------------------------------------+
   | HipHop for PHP                                                       |
   +----------------------------------------------------------------------+
   | Copyright (c) 2010-2013 Facebook, Inc. (http://www.facebook.com)     |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.01 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_01.txt                                  |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
*/

#include "hphp/runtime/vm/jit/region-selection.h"
#include "hphp/runtime/base/memory/smart_containers.h"

namespace HPHP { namespace JIT {

//////////////////////////////////////////////////////////////////////

/*
 * A dummy (debugging) region selector that just uses a single HHBC
 * opcode as the region, and guards on everything.
 */
RegionDescPtr regionOneBC(const RegionContext& ctx) {
  auto ret = smart::make_unique<RegionDesc>();
  auto blk = smart::make_unique<RegionDesc::Block>(ctx.func, ctx.offset, 1);

  for (auto& live : ctx.liveTypes) {
    blk->addPredicted(SrcKey{ctx.func, ctx.offset},
                      {live.location, live.type});
  }

  ret->blocks.emplace_back(std::move(blk));
  return ret;
}

//////////////////////////////////////////////////////////////////////

}}
